package mediationci;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import javax.swing.Timer;


/**
 *
 * @author falk
 * 
 *  Copyright 2012-2014 Carl F. Falk
 * 
 * This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
public class HBFrame extends javax.swing.JFrame {

    /**
     * Creates new form PPFrame
     */
    public HBFrame() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        title = new javax.swing.JLabel();
        inputTitle = new javax.swing.JLabel();
        est1Label = new javax.swing.JLabel();
        est1TextField = new javax.swing.JTextField();
        se1Label = new javax.swing.JLabel();
        se1TextField = new javax.swing.JTextField();
        est2Label = new javax.swing.JLabel();
        est2TextField = new javax.swing.JTextField();
        df2Label = new javax.swing.JLabel();
        df2TextField = new javax.swing.JTextField();
        computeTitle = new javax.swing.JLabel();
        accuracyButton1 = new javax.swing.JRadioButton();
        accuracyButton2 = new javax.swing.JRadioButton();
        computeButton = new javax.swing.JButton();
        CIValLabel = new javax.swing.JLabel();
        CIValValue = new javax.swing.JLabel();
        progressLabel = new javax.swing.JLabel();
        jProgressBar1 = new javax.swing.JProgressBar();
        CITextField = new javax.swing.JTextField();
        CIsizeLabel = new javax.swing.JLabel();
        df1TextField = new javax.swing.JTextField();
        df1Label = new javax.swing.JLabel();
        se2Label = new javax.swing.JLabel();
        se2TextField = new javax.swing.JTextField();
        computeTitle1 = new javax.swing.JLabel();
        HBmethodButton = new javax.swing.JRadioButton();
        MCmethodButton = new javax.swing.JRadioButton();
        corab = new javax.swing.JLabel();
        corabTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Confidence interval calculator for mediation analysis");

        title.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        title.setText("Mediation Analysis Confidence Interval Calculator");

        inputTitle.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        inputTitle.setText("Input");

        est1Label.setText("Estimate for Path A:");

        se1Label.setText("Standard error for A:");

        est2Label.setText("Estimate for Path B:");

        df2Label.setText("df for Model B:");

        computeTitle.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        computeTitle.setText("Computational Accuracy & Speed");

        buttonGroup1.add(accuracyButton1);
        accuracyButton1.setSelected(true);
        accuracyButton1.setText("Good (fast)");

        buttonGroup1.add(accuracyButton2);
        accuracyButton2.setText("Excellent (slow)");

        computeButton.setText("Compute");
        computeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                computeButtonActionPerformed(evt);
            }
        });

        CIValLabel.setText("CI:");

        CIValValue.setText("-----");

        CITextField.setText(".95");

        CIsizeLabel.setText("% CI");

        df1Label.setText("df for Model A:");

        se2Label.setText("Standard error for B:");

        computeTitle1.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        computeTitle1.setText("Computational Method");

        buttonGroup2.add(HBmethodButton);
        HBmethodButton.setSelected(true);
        HBmethodButton.setText("Hierarchical Bayes");
        HBmethodButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                HBmethodButtonActionPerformed(evt);
            }
        });

        buttonGroup2.add(MCmethodButton);
        MCmethodButton.setText("Normal Approx. (aka, Monte Carlo)");
        MCmethodButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MCmethodButtonActionPerformed(evt);
            }
        });

        corab.setText("rho, or Cor (A,B)");

        corabTextField.setText("0");
        corabTextField.setEnabled(false);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(0, 101, Short.MAX_VALUE)
                .add(title)
                .add(85, 85, 85))
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(est1Label)
                                        .add(se1Label)
                                        .add(est2Label))
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, df1Label))
                                .add(org.jdesktop.layout.GroupLayout.LEADING, df2Label))
                            .add(se2Label)
                            .add(corab))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(corabTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 108, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(est1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 108, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(se1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 108, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(df1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 108, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(est2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 102, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(se2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 104, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(df2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 108, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(23, 23, 23)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(computeTitle1)
                            .add(MCmethodButton)
                            .add(HBmethodButton)
                            .add(accuracyButton1)
                            .add(accuracyButton2)
                            .add(computeTitle)
                            .add(layout.createSequentialGroup()
                                .add(CIsizeLabel)
                                .add(1, 1, 1)
                                .add(CITextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 56, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(layout.createSequentialGroup()
                        .add(32, 32, 32)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(computeButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(CIValLabel)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(CIValValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(jProgressBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 206, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(progressLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 196, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(layout.createSequentialGroup()
                        .add(6, 6, 6)
                        .add(inputTitle)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(new java.awt.Component[] {df1TextField, df2TextField, est1TextField, est2TextField, se1TextField, se2TextField}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(title)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(inputTitle)
                    .add(computeTitle))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(est1Label)
                    .add(est1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(accuracyButton1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(se1Label)
                    .add(se1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(accuracyButton2))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(15, 15, 15)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(CITextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(CIsizeLabel))
                        .add(30, 30, 30)
                        .add(computeTitle1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(HBmethodButton)
                        .add(4, 4, 4)
                        .add(MCmethodButton)
                        .add(18, 18, 18))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(df1TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(df1Label))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(est2Label)
                            .add(est2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(se2Label)
                            .add(se2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(df2TextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(df2Label))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(corab)
                            .add(corabTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(2, 2, 2)))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(computeButton)
                    .add(CIValLabel)
                    .add(CIValValue))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(progressLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jProgressBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(20, 20, 20))
        );

        layout.linkSize(new java.awt.Component[] {df1TextField, df2TextField, est1TextField, est2TextField, se1TextField, se2TextField}, org.jdesktop.layout.GroupLayout.VERTICAL);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    HBCalc hb1;
    NumberFormat format;

    private Timer timer = new Timer(1000, new ActionListener() {

        @Override
            public void actionPerformed(ActionEvent evt) {
                jProgressBar1.setValue(hb1.getProgress());
                if (hb1.getDone()) {
                    timer.stop();
                    computeButton.setEnabled(true);
                    se1TextField.setEnabled(true);
                    se2TextField.setEnabled(true);
                    if(HBmethodButton.isSelected()){
                        df1TextField.setEnabled(true);
                        df2TextField.setEnabled(true);
                    } else {
                        corabTextField.setEnabled(true);     
                    }
                    accuracyButton1.setEnabled(true);
                    accuracyButton2.setEnabled(true);
                    est1TextField.setEnabled(true);
                    est2TextField.setEnabled(true);
                    CITextField.setEnabled(true);
                    HBmethodButton.setEnabled(true);
                    MCmethodButton.setEnabled(true);

                    jProgressBar1.setValue(jProgressBar1.getMinimum());
                    final double lower=hb1.getLower();
                    final double upper=hb1.getUpper();
                                                        
                    CIValValue.setText("[" + format.format(lower) + ", " + format.format(upper) + "]");
                    
                    jProgressBar1.setValue(0);
                    progressLabel.setText("");
                }
            }
        });

    
    private void computeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_computeButtonActionPerformed
        double path1 = Double.parseDouble(est1TextField.getText());
        double path2 = Double.parseDouble(est2TextField.getText());
        double se1 = Double.parseDouble(se1TextField.getText());
        double se2 = Double.parseDouble(se2TextField.getText());
        double pci = Double.parseDouble(CITextField.getText());
        int df1 = 0;
        int df2 = 0;
        double cor = 0;        
        if(HBmethodButton.isSelected()){
           df1 = Integer.parseInt(df1TextField.getText());
           df2 = Integer.parseInt(df2TextField.getText());
        } else {
           cor = Double.parseDouble(corabTextField.getText());            
        }


        computeButton.setEnabled(false);
        df1TextField.setEnabled(false);
        df2TextField.setEnabled(false);
        se1TextField.setEnabled(false);
        se2TextField.setEnabled(false);
        accuracyButton1.setEnabled(false);
        accuracyButton2.setEnabled(false);
        est1TextField.setEnabled(false);
        est2TextField.setEnabled(false);
        CITextField.setEnabled(false);
        HBmethodButton.setEnabled(false);
        MCmethodButton.setEnabled(false);
        corabTextField.setEnabled(false);     
        
        
        CIValValue.setText("----");
        progressLabel.setText("Calculating, please wait");

        if (accuracyButton1.isSelected()){
            if(HBmethodButton.isSelected()){
                hb1 = new HBCalc(path1, path2, se1, se2, df1, df2, 100, 200000, pci);
            } else {
                hb1 = new HBCalc(path1,path2,se1,se2,cor,100,200000,pci);
            }
            format = new DecimalFormat("0.000");
            
        } else if (accuracyButton2.isSelected()){
            if(HBmethodButton.isSelected()){
                hb1 = new HBCalc(path1, path2, se1, se2, df1, df2, 500, 200000, pci);
            } else {
                hb1 = new HBCalc(path1,path2,se1,se2,cor,500,200000,pci);
            }
            format = new DecimalFormat("0.0000");
        }
        
        jProgressBar1.setMinimum(0);
        jProgressBar1.setMaximum(hb1.getrep());
        jProgressBar1.setStringPainted(true);
        hbThread hb1Thread = new hbThread(hb1);      
        hb1Thread.start(); // start thread
        timer.start(); // start timer that updates GUI
    }//GEN-LAST:event_computeButtonActionPerformed

private void HBmethodButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_HBmethodButtonActionPerformed
     df1TextField.setEnabled(true);
     df2TextField.setEnabled(true);
     corabTextField.setEnabled(false);     
}//GEN-LAST:event_HBmethodButtonActionPerformed

private void MCmethodButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MCmethodButtonActionPerformed
     df1TextField.setEnabled(false);
     df2TextField.setEnabled(false);
     corabTextField.setEnabled(true);
}//GEN-LAST:event_MCmethodButtonActionPerformed

    /**
     * @param args the command line arguments
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField CITextField;
    private javax.swing.JLabel CIValLabel;
    private javax.swing.JLabel CIValValue;
    private javax.swing.JLabel CIsizeLabel;
    private javax.swing.JRadioButton HBmethodButton;
    private javax.swing.JRadioButton MCmethodButton;
    private javax.swing.JRadioButton accuracyButton1;
    private javax.swing.JRadioButton accuracyButton2;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JButton computeButton;
    private javax.swing.JLabel computeTitle;
    private javax.swing.JLabel computeTitle1;
    private javax.swing.JLabel corab;
    private javax.swing.JTextField corabTextField;
    private javax.swing.JLabel df1Label;
    private javax.swing.JTextField df1TextField;
    private javax.swing.JLabel df2Label;
    private javax.swing.JTextField df2TextField;
    private javax.swing.JLabel est1Label;
    private javax.swing.JTextField est1TextField;
    private javax.swing.JLabel est2Label;
    private javax.swing.JTextField est2TextField;
    private javax.swing.JLabel inputTitle;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JLabel progressLabel;
    private javax.swing.JLabel se1Label;
    private javax.swing.JTextField se1TextField;
    private javax.swing.JLabel se2Label;
    private javax.swing.JTextField se2TextField;
    private javax.swing.JLabel title;
    // End of variables declaration//GEN-END:variables
}
    class hbThread extends Thread {
        private HBCalc hb;

        // constructor
        public hbThread(HBCalc hbCalc) {
           this.hb = hbCalc;
        }

    @Override
        public void run() {
            hb.calcHBVal();
            System.gc();
        }
    }